#  2008 Nhaga
# Version 0.1
# A python script to change active standby codes for N95

import appuifw, e32, os, globalui

Items= [u'Shortcut',u'Search', u'Organizer', u'Todo', u'Media Player', u'Aioperatorplugin', u'Wlan', u'Share', u'Radio', u'Printintent']
Positions = [42, 54, 66, 78, 90, 102, 114, 126, 138, 150]
Correct = [0,32,0,16,16,16,16,0,16,32]
PluginFile = 'C:\RESOURCE\AIPluginDefinition.rsc'

def help():
    globalui.global_msg_query(u'1.Disable Active Standby\n2.Make sure you have CapsOff\n3.Change Items\n4.Save file\n5.Enable Active Standby',u"Instructions")

def CapsOff():
    try:
        e32.start_exe('C:\\SYS\\BIN\\CapsOff.exe','',1)
    except:
        appuifw.note(u"CapsOff not found!", "error")
        app_lock.signal()
    
def CopyFile():
    SaveFile()
    source = PluginFile
    target = 'C:\\RESOURCE'
    try:
        e32.file_copy(target, source)
        appuifw.note(u"File copied successfully", "conf")
    except:
        appuifw.note(u"File NOT copied!\n\n(Disable ActiveStandby\nand must have CapsOff)", "conf")
def SaveFile():
    t2 = '' 
    for elem in list: 
        t2 += chr(elem) 
    myfile = open(PluginFile,'wb')
    myfile.write(t2)
    myfile.close
    appuifw.note(u"File Saved", "conf")
    #app_lock.signal()

def ChangeItem(x):
    if list[Positions[x]-1] == Correct[x]:
        list[Positions[x]-1] = 17
    else:
        list[Positions[x]-1] = Correct[x]
    ShowText()

def a0():
    ChangeItem(0)

def a1():
    ChangeItem(1)
    
def a2():
    ChangeItem(2)

def a3():
    ChangeItem(3)

def a4():
    ChangeItem(4)

def a5():
    ChangeItem(5)

def a6():
    ChangeItem(6)

def a7():
    ChangeItem(7)

def a8():
    ChangeItem(8)

def a9():
    ChangeItem(9)

    

def ShowText():
    appuifw.app.body = None
    text = appuifw.Text()
    text.font = "legend"
    text.add(u'Available Items\n\n')
    text.font = "dense"
    for i in range(len(Items)):
        text.color = (0,0,0)
        text.add(Items[i])
        text.add(u'........')	
        if list[Positions[i]-1] == Correct[i]:
            text.color = (0,255,0)
            text.add(u'On\n')
        else:
            text.color = (255,0,0)
            text.add(u'Off\n')
    appuifw.app.body = text

def quit():
    app_lock.signal()


appuifw.app.exit_key_handler = quit
appuifw.app.title = u"ActiveStandby"
appuifw.app.menu = [(u'Change',
                                        ((Items[0],a0),
                                        (Items[1],a1),
                                        (Items[2],a2),
                                        (Items[3],a3),
                                        (Items[4],a4),
                                        (Items[5],a5),
                                        (Items[6],a6),
                                        (Items[7],a7),
                                        (Items[8],a8),
                                        (Items[9],a9))),
                                        (u'Save File',SaveFile),
                                        (u'Help',help),
                                        (u'Exit',quit)]


app_lock = e32.Ao_lock()
CapsOff()
try:
        myfile = open(PluginFile,'rb')
        a = myfile.read()
        myfile.close()
        list = []
        for letter in a: 
            list.append(ord(letter))
        ShowText()
except:
        appuifw.note(u"File not found\nPlease put file in root of memory card", "error")
        app_lock.signal()

app_lock.wait()